/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser.y" /* yacc.c:339  */

/*
 * Copyright 2013 Google Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
/*
 * Author: Author: ncardwell@google.com (Neal Cardwell)
 *
 * This is the parser for the packetdrill script language. It is
 * processed by the bison parser generator.
 *
 * For full documentation see: http://www.gnu.org/software/bison/manual/
 *
 * Here is a quick and dirty tutorial on bison:
 *
 * A bison parser specification is basically a BNF grammar for the
 * language you are parsing. Each rule specifies a nonterminal symbol
 * on the left-hand side and a sequence of terminal symbols (lexical
 * tokens) and or nonterminal symbols on the right-hand side that can
 * "reduce" to the symbol on the left hand side. When the parser sees
 * the sequence of symbols on the right where it "wants" to see a
 * nonterminal on the left, the rule fires, executing the semantic
 * action code in curly {} braces as it reduces the right hand side to
 * the left hand side.
 *
 * The semantic action code for a rule produces an output, which it
 * can reference using the $$ token. The set of possible types
 * returned in output expressions is given in the %union section of
 * the .y file. The specific type of the output for a terminal or
 * nonterminal symbol (corresponding to a field in the %union) is
 * given by the %type directive in the .y file. The action code can
 * access the outputs of the symbols on the right hand side by using
 * the notation $1 for the first symbol, $2 for the second symbol, and
 * so on.
 *
 * The lexer (generated by flex from lexer.l) feeds a stream of
 * terminal symbols up to this parser. Parser semantic actions can
 * access the lexer output for a terminal symbol with the same
 * notation they use for nonterminals.
 *
 * Here's an example rule with its semantic action in {} braces:
 *
 *     tcp_option
 *     ...
 *      | MSS INTEGER   {
 *        $$ = tcp_option_new(...);
 *        ...
 *        $$->data.mss.bytes = htons($2);
 *      }
 *
 * This rule basically says:
 *
 *   When the parser wants to see a tcp_option, if it sees an MSS from
 *   the lexer followed by an INTEGER from the lexer then run the
 *   action code that (a) stores in the output $$ a pointer to a
 *   struct tcp_option object, and then (b) stores in that object the
 *   value of the INTEGER token (accessed with $2).
 *
 */

/* The first part of the .y file consists of C code that bison copies
 * directly into the top of the .c file it generates.
 */

#include "types.h"

#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "gre_packet.h"
#include "ip.h"
#include "ip_packet.h"
#include "icmp_packet.h"
#include "logging.h"
#include "mpls.h"
#include "mpls_packet.h"
#include "tcp_packet.h"
#include "udp_packet.h"
#include "parse.h"
#include "script.h"
#include "tcp.h"
#include "tcp_options.h"

/* This include of the bison-generated .h file must go last so that we
 * can first include all of the declarations on which it depends.
 */
#include "parser.h"

/* Change this YYDEBUG to 1 to get verbose debug output for parsing: */
#define YYDEBUG 0
#if YYDEBUG
extern int yydebug;
#endif

extern FILE *yyin;
extern int yylineno;
extern char *yytext;
extern int yylex(void);
extern int yyparse(void);
extern int yywrap(void);
extern const char *cleanup_cmd;

/* This mutex guards all parser global variables declared in this file. */
pthread_mutex_t parser_mutex = PTHREAD_MUTEX_INITIALIZER;

/* The input to the parser: the path name of the script file to parse. */
static const char* current_script_path = NULL;

/* The starting line number of the input script statement that we're
 * currently parsing. This may be different than yylineno if bison had
 * to look ahead and lexically scan a token on the following line to
 * decide that the current statement is done.
 */
static int current_script_line = -1;

/*
 * We uses this object to look up configuration info needed during
 * parsing (such as whether packets are IPv4 or IPv6).
 */
struct config *in_config = NULL;

/* The output of the parser: an output script containing
 * 1) a linked list of options
 * 2) a linked list of events
 */
static struct script *out_script = NULL;

/* The test invocation to pass back to parse_and_finalize_config(). */
struct invocation *invocation;

/* Copy the script contents into our single linear buffer. */
void copy_script(const char *script_buffer, struct script *script)
{
	DEBUGP("copy_script\n");

	free(script->buffer);
	script->length = strlen(script_buffer);
	script->buffer = strdup(script_buffer);
	assert(script->buffer != NULL);

	DEBUGP("copy_script: %d bytes\n", script->length);
}

/* Read the script file into a single linear buffer. */
void read_script(const char *script_path, struct script *script)
{
	int size = 0;

	DEBUGP("read_script(%s)\n", script_path);

	while (script->buffer == NULL) {
		struct stat script_info;
		int fd = -1;

		/* Allocate a buffer big enough for the whole file. */
		if (stat(script_path, &script_info) != 0)
			die("parse error: stat() of script file '%s': %s\n",
			    script_path, strerror(errno));

		/* Pick a buffer size larger than the file, so we'll
		 * know if the file grew.
		 */
		size = max((int)script_info.st_size, size) + 1;

		script->buffer = malloc(size);
		assert(script->buffer != NULL);

		/* Read the file into our buffer. */
		fd = open(script_path, O_RDONLY);
		if (fd < 0)
			die("parse error opening script file '%s': %s\n",
			    script_path, strerror(errno));

		script->length = read(fd, script->buffer, size);
		if (script->length < 0)
			die("parse error reading script file '%s': %s\n",
			    script_path, strerror(errno));

		/* If we filled the buffer, then probably another
		 * process wrote more to the file since our stat call,
		 * so we should try again.
		 */
		if (script->length == size) {
			free(script->buffer);
			script->buffer = NULL;
			script->length = 0;
		}

		if (close(fd))
			die_perror("close");
	}
	DEBUGP("read_script: %d bytes\n", script->length);
}


/* The public entry point for the script parser. Parses the
 * text script file with the given path name and fills in the script
 * object with the parsed representation.
 */
int parse_script(struct config *config,
		 struct script *script,
		 struct invocation *callback_invocation)
{
	/* This bison-generated parser is not multi-thread safe, so we
	 * have a lock to prevent more than one thread using the
	 * parser at the same time. This is useful in the wire server
	 * context, where in general we may have more than one test
	 * thread running at the same time.
	 */
	if (pthread_mutex_lock(&parser_mutex) != 0)
		die_perror("pthread_mutex_lock");

#if YYDEBUG
	yydebug = 1;
#endif

	/* Now parse the script from our buffer. */
	yyin = fmemopen(script->buffer, script->length, "r");
	if (yyin == NULL)
		die_perror("fmemopen: parse error opening script buffer");

	current_script_path = config->script_path;
	in_config = config;
	out_script = script;
	invocation = callback_invocation;

	/* We have to reset the line number here since the wire server
	 * can do more than one yyparse().
	 */
	yylineno = 1;

	int result = yyparse();		/* invoke bison-generated parser */
	current_script_path = NULL;

	if (fclose(yyin))
		die_perror("fclose: error closing script buffer");

	/* Unlock parser. */
	if (pthread_mutex_unlock(&parser_mutex) != 0)
		die_perror("pthread_mutex_unlock");

	return result ? STATUS_ERR : STATUS_OK;
}

/* Bison emits code to call this method when there's a parse-time error.
 * We print the line number and the error message.
 */
static void yyerror(const char *message)
{
	fprintf(stderr, "%s:%d: parse error at '%s': %s\n",
		current_script_path, yylineno, yytext, message);
}

/* After we finish parsing each line of a script, we analyze the
 * semantics of the line. If we encounter an error then we print the
 * error message to stderr and exit with an error.
 */
static void semantic_error(const char* message)
{
	assert(current_script_line >= 0);
	die("%s:%d: semantic error: %s\n",
	    current_script_path, current_script_line, message);
}

/* This standard callback is invoked by flex when it encounters
 * the end of a file. We return 1 to tell flex to return EOF.
 */
int yywrap(void)
{
	return 1;
}

/* Create and initalize a new expression. */
static struct expression *new_expression(enum expression_t type)
{
	struct expression *expression = calloc(1, sizeof(struct expression));
	expression->type = type;
	return expression;
}

/* Create and initalize a new integer expression with the given
 * literal value and format string.
 */
static struct expression *new_integer_expression(s64 num, const char *format)
{
	struct expression *expression = new_expression(EXPR_INTEGER);
	expression->value.num = num;
	expression->format = format;
	return expression;
}

/* Create and initalize a new one-element expression_list. */
static struct expression_list *new_expression_list(
	struct expression *expression)
{
	struct expression_list *list;
	list = calloc(1, sizeof(struct expression_list));
	list->expression = expression;
	list->next = NULL;
	return list;
}

/* Add the expression to the end of the list. */
static void expression_list_append(struct expression_list *list,
				   struct expression *expression)
{
	while (list->next != NULL) {
		list = list->next;
	}
	list->next = new_expression_list(expression);
}

/* Create and initialize a new option. */
static struct option_list *new_option(char *name, char *value)
{
	struct option_list *opt = calloc(1, sizeof(struct option_list));
	opt->name = name;
	opt->value = value;
	return opt;
}

/* Create and initialize a new event. */
static struct event *new_event(enum event_t type)
{
	struct event *e = calloc(1, sizeof(struct event));
	e->type = type;
	e->time_usecs_end = NO_TIME_RANGE;
	e->offset_usecs = NO_TIME_RANGE;
	return e;
}

static int parse_hex_byte(const char *hex, u8 *byte)
{
	if (!isxdigit((int)hex[0]) || !isxdigit((int)hex[1])) {
		return STATUS_ERR;	/* need two hex digits per byte */
	}
	char buf[] = { hex[0], hex[1], '\0' };
	char* buf_end = NULL;
	u32 byte_value = strtoul(buf, &buf_end, 16);
	assert(byte_value <= 0xff);
	assert(buf_end == buf + 2);
	*byte = byte_value;
	return STATUS_OK;
}

/* Converts a hex string in 'hex' into bytes and stores them in a
 * buffer 'buf' of length 'buf_len' bytes; returns number of bytes in
 * out_len. Works for hex strings of arbitrary size, such as very long
 * TCP Fast Open cookies.
 */
static int parse_hex_string(const char *hex, u8 *buf, int buf_len,
			    int *out_len)
{
	u8 *out = buf;
	u8 *buf_end = buf + buf_len;
	while (hex[0] != '\0') {
		if (out >= buf_end) {
			return STATUS_ERR;	/* ran out of output space */
		}
		if (parse_hex_byte(hex, out))
			return STATUS_ERR;	/* bad character */
		hex += 2;
		out += 1;
	}
	*out_len = out - buf;
	assert(*out_len <= buf_len);
	return STATUS_OK;
}

static struct tcp_option *new_tcp_fast_open_option(const char *cookie_string,
						   char **error, bool exp)
{
	int cookie_string_len = strlen(cookie_string);
	if (cookie_string_len & 1) {
		asprintf(error,
			 "TCP fast open cookie has an odd number of digits");
		return NULL;
	}
	int cookie_bytes = cookie_string_len / 2;  /* 2 hex chars per byte */
	int max_bytes = exp ? MAX_TCP_FAST_OPEN_EXP_COOKIE_BYTES :
			      MAX_TCP_FAST_OPEN_COOKIE_BYTES;
	if (cookie_bytes > max_bytes) {
		asprintf(error, "TCP fast open cookie too long");
		asprintf(error, "TCP fast open cookie of %d bytes "
			 "exceeds maximum cookie length of %d bytes",
			 cookie_bytes, max_bytes);
		return NULL;
	}
	u8 option_bytes = cookie_bytes + (exp ? TCPOLEN_EXP_FASTOPEN_BASE :
	                                        TCPOLEN_FASTOPEN_BASE);
	struct tcp_option *option;
	option = tcp_option_new(exp ? TCPOPT_EXP : TCPOPT_FASTOPEN,
				option_bytes);
	if (exp)
		option->data.fast_open_exp.magic = htons(TCPOPT_FASTOPEN_MAGIC);

	int parsed_bytes = 0;
	/* Parse cookie. This should be an ASCII hex string
	 * representing an even number of bytes (4-16 bytes). But we
	 * do not enforce this, since we want to allow test cases that
	 * supply invalid cookies.
	 */
	if (parse_hex_string(cookie_string,
			     exp ? option->data.fast_open_exp.cookie :
				   option->data.fast_open.cookie,
			     exp ? sizeof(option->data.fast_open_exp.cookie):
			           sizeof(option->data.fast_open.cookie),
			     &parsed_bytes)) {
		free(option);
		asprintf(error,
			 "TCP fast open cookie '%s' is not a valid hex string",
			cookie_string);
		return NULL;
	}
	assert(parsed_bytes == cookie_bytes);
	return option;
}

static struct tcp_option *new_md5_option(const char *digest_string,
					 char **error)
{
	struct tcp_option *option;
	int digest_string_len = strlen(digest_string);
	int digest_bytes = digest_string_len / 2;
	int parsed_bytes = 0;

	if (digest_bytes > TCP_MD5_DIGEST_LEN) {
		asprintf(error, "TCP MD5 digest longer than 16 bytes");
		return NULL;
	}

	option = tcp_option_new(TCPOPT_MD5SIG, TCPOLEN_MD5_BASE + digest_bytes);

	/* Parse MD5 digest. This should be an ASCII hex string representing 16
	 * bytes. But we allow smaller buffers, since we want to allow test
	 * cases that supply invalid cookies.
	 */
	if (parse_hex_string(digest_string,
			     option->data.md5.digest,
			     sizeof(option->data.md5.digest),
			     &parsed_bytes)) {
		free(option);
		asprintf(error, "TCP MD5 digest is not a valid hex string");
		return NULL;
	}
	assert(parsed_bytes <= digest_bytes);
	return option;
}

static struct packet *append_gre(struct packet *packet, struct expression *expr)
{
	struct gre *gre = &expr->value.gre;
	char *error = NULL;
	if (gre_header_append(packet, gre, &error))
		semantic_error(error);
	free(expr);
	return packet;
}


#line 550 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ELLIPSIS = 258,
    SA_FAMILY = 259,
    SIN_PORT = 260,
    SIN_ADDR = 261,
    _HTONS_ = 262,
    INET_ADDR = 263,
    INET6_ADDR = 264,
    MSG_NAME = 265,
    MSG_IOV = 266,
    MSG_FLAGS = 267,
    MSG_CONTROL = 268,
    CMSG_LEVEL = 269,
    CMSG_TYPE = 270,
    CMSG_DATA = 271,
    FD = 272,
    EVENTS = 273,
    REVENTS = 274,
    ONOFF = 275,
    LINGER = 276,
    U32 = 277,
    U64 = 278,
    PTR = 279,
    ACK = 280,
    ECR = 281,
    EOL = 282,
    MSS = 283,
    NOP = 284,
    SACK = 285,
    SACKOK = 286,
    TIMESTAMP = 287,
    VAL = 288,
    WIN = 289,
    WSCALE = 290,
    URG = 291,
    MD5 = 292,
    FAST_OPEN = 293,
    FAST_OPEN_EXP = 294,
    TOS = 295,
    FLAGS = 296,
    FLOWLABEL = 297,
    ECT0 = 298,
    ECT1 = 299,
    CE = 300,
    ECT01 = 301,
    NO_ECN = 302,
    IPV4 = 303,
    IPV6 = 304,
    ICMP = 305,
    UDP = 306,
    RAW = 307,
    GRE = 308,
    MTU = 309,
    ID = 310,
    MPLS = 311,
    LABEL = 312,
    TC = 313,
    TTL = 314,
    OPTION = 315,
    SUM = 316,
    OFF = 317,
    KEY = 318,
    SEQ = 319,
    NONE = 320,
    CHECKSUM = 321,
    SEQUENCE = 322,
    PRESENT = 323,
    EE_ERRNO = 324,
    EE_CODE = 325,
    EE_DATA = 326,
    EE_INFO = 327,
    EE_ORIGIN = 328,
    EE_TYPE = 329,
    SCM_SEC = 330,
    SCM_NSEC = 331,
    FLOAT = 332,
    INTEGER = 333,
    HEX_INTEGER = 334,
    WORD = 335,
    STRING = 336,
    BACK_QUOTED = 337,
    CODE = 338,
    IPV4_ADDR = 339,
    IPV6_ADDR = 340
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 490 "parser.y" /* yacc.c:355  */

	s64 integer;
	double floating;
	char *string;
	char *reserved;
	s64 time_usecs;
	enum direction_t direction;
	u8 ip_ecn;
	struct tos_spec tos_spec;
	struct ip_info ip_info;
	struct mpls_stack *mpls_stack;
	struct mpls mpls_stack_entry;
	u16 port;
	s32 window;
	u16 urg_ptr;
	u32 sequence_number;
	struct {
		int protocol;		/* IPPROTO_TCP or IPPROTO_UDP */
		u32 start_sequence;
		u16 payload_bytes;
	} tcp_sequence_info;
	struct option_list *option;
	struct event *event;
	struct packet *packet;
	struct syscall_spec *syscall;
	struct command_spec *command;
	struct code_spec *code;
	struct tcp_option *tcp_option;
	struct tcp_options *tcp_options;
	struct expression *expression;
	struct expression_list *expression_list;
	struct errno_spec *errno_info;
	struct {
		u16 src_port;
		u16 dst_port;
	} port_info;

#line 714 "parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 745 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   477

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  103
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  95
/* YYNRULES -- Number of rules.  */
#define YYNRULES  211
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  454

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   340

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      90,    91,    88,    87,    96,    99,    98,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    93,     2,
      97,    86,    92,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    94,     2,    95,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   100,   102,   101,    89,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   601,   601,   607,   611,   618,   622,   629,   632,   637,
     641,   642,   643,   644,   645,   646,   647,   648,   656,   664,
     675,   676,   680,   684,   689,   696,   725,   731,   737,   742,
     749,   759,   765,   774,   775,   776,   777,   781,   782,   783,
     787,   820,   846,   873,   877,   890,   903,   908,   913,   926,
     941,   942,   946,   947,   951,   952,   953,   954,   958,   962,
     966,   970,   974,   975,   979,   980,   984,   987,   996,  1012,
    1013,  1022,  1026,  1027,  1032,  1037,  1042,  1045,  1052,  1053,
    1057,  1058,  1062,  1066,  1080,  1081,  1085,  1086,  1087,  1100,
    1101,  1102,  1103,  1107,  1110,  1116,  1119,  1125,  1131,  1132,
    1133,  1134,  1138,  1149,  1155,  1161,  1167,  1176,  1182,  1183,
    1187,  1208,  1209,  1218,  1219,  1228,  1229,  1238,  1239,  1240,
    1244,  1250,  1259,  1260,  1264,  1265,  1269,  1270,  1271,  1278,
    1285,  1289,  1292,  1302,  1316,  1326,  1339,  1340,  1355,  1369,
    1382,  1383,  1387,  1391,  1392,  1396,  1397,  1401,  1404,  1405,
    1410,  1413,  1419,  1422,  1425,  1428,  1431,  1434,  1437,  1440,
    1443,  1446,  1449,  1452,  1455,  1458,  1461,  1464,  1470,  1471,
    1475,  1481,  1487,  1496,  1499,  1511,  1520,  1534,  1538,  1545,
    1552,  1563,  1595,  1612,  1613,  1617,  1630,  1643,  1650,  1670,
    1680,  1691,  1697,  1703,  1709,  1719,  1720,  1724,  1733,  1740,
    1741,  1749,  1750,  1754,  1758,  1759,  1760,  1764,  1772,  1780,
    1781,  1785
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ELLIPSIS", "SA_FAMILY", "SIN_PORT",
  "SIN_ADDR", "_HTONS_", "INET_ADDR", "INET6_ADDR", "MSG_NAME", "MSG_IOV",
  "MSG_FLAGS", "MSG_CONTROL", "CMSG_LEVEL", "CMSG_TYPE", "CMSG_DATA", "FD",
  "EVENTS", "REVENTS", "ONOFF", "LINGER", "U32", "U64", "PTR", "ACK",
  "ECR", "EOL", "MSS", "NOP", "SACK", "SACKOK", "TIMESTAMP", "VAL", "WIN",
  "WSCALE", "URG", "MD5", "FAST_OPEN", "FAST_OPEN_EXP", "TOS", "FLAGS",
  "FLOWLABEL", "ECT0", "ECT1", "CE", "ECT01", "NO_ECN", "IPV4", "IPV6",
  "ICMP", "UDP", "RAW", "GRE", "MTU", "ID", "MPLS", "LABEL", "TC", "TTL",
  "OPTION", "SUM", "OFF", "KEY", "SEQ", "NONE", "CHECKSUM", "SEQUENCE",
  "PRESENT", "EE_ERRNO", "EE_CODE", "EE_DATA", "EE_INFO", "EE_ORIGIN",
  "EE_TYPE", "SCM_SEC", "SCM_NSEC", "FLOAT", "INTEGER", "HEX_INTEGER",
  "WORD", "STRING", "BACK_QUOTED", "CODE", "IPV4_ADDR", "IPV6_ADDR", "'='",
  "'+'", "'*'", "'~'", "'('", "')'", "'>'", "':'", "'['", "']'", "','",
  "'<'", "'.'", "'-'", "'{'", "'}'", "'|'", "$accept", "script",
  "opt_options", "options", "option", "option_flag", "option_value",
  "opt_init_command", "init_command", "events", "event", "event_time",
  "time", "action", "packet_spec", "tcp_packet_spec", "udp_packet_spec",
  "icmp_packet_spec", "packet_prefix", "gre_header_expression",
  "gre_flags_list", "gre_flags", "gre_flag", "gre_sum", "gre_off",
  "gre_key", "gre_seq", "opt_comma", "opt_equals", "mpls_stack",
  "mpls_stack_entry", "opt_mpls_stack_bottom", "icmp_type",
  "opt_icmp_code", "opt_icmp_echoed", "opt_icmp_mtu", "opt_icmp_echo_id",
  "opt_port_info", "direction", "tos_spec", "ip_ecn", "opt_ack_flag",
  "opt_word", "ack_and_ace", "flags", "flow_label", "ip_info",
  "opt_ip_info", "seq", "opt_ack", "opt_window", "opt_urg_ptr",
  "opt_tcp_options", "tcp_option_list", "opt_tcp_fast_open_cookie",
  "hex_blob", "tcp_option", "sack_block_list", "sack_block",
  "syscall_spec", "opt_end_time", "function_name", "function_arguments",
  "expression_list", "expression", "any_int", "decimal_integer",
  "hex_integer", "string_expression", "string_sequence",
  "binary_expression", "array", "inaddr", "in6addr", "sockaddr", "msghdr",
  "opt_cmsg", "cmsg_expr", "scm_timestamping_expr", "sub_expr_list",
  "sock_extended_err_expr", "iovec", "pollfd", "epollev", "opt_revents",
  "linger", "mpls_stack_expression", "opt_errno", "opt_note", "note",
  "word_list", "command_spec", "code_spec", "opt_cleanup_command",
  "cleanup_command", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    61,    43,    42,   126,
      40,    41,    62,    58,    91,    93,    44,    60,    46,    45,
     123,   125,   124
};
# endif

#define YYPACT_NINF -411

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-411)))

#define YYTABLE_NINF -97

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       3,  -411,    79,    26,     3,  -411,    36,  -411,  -411,   -22,
    -411,  -411,  -411,    54,  -411,  -411,    18,  -411,   129,  -411,
       0,    67,  -411,  -411,  -411,    39,  -411,  -411,  -411,  -411,
      90,  -411,  -411,  -411,  -411,    18,  -411,  -411,  -411,  -411,
    -411,  -411,  -411,  -411,     4,  -411,  -411,   139,  -411,  -411,
      18,   -50,   138,  -411,   -20,   -20,   128,  -411,   117,   117,
     -45,  -411,   141,  -411,  -411,  -411,  -411,    18,   152,   153,
    -411,  -411,   196,   -42,   160,   161,  -411,  -411,  -411,  -411,
    -411,   163,   146,  -411,  -411,   155,   148,   164,   169,   156,
     -26,    10,   165,  -411,   157,   158,   -17,   159,   162,   197,
    -411,  -411,  -411,  -411,  -411,   211,  -411,  -411,  -411,   176,
     167,   177,   -55,  -411,  -411,   182,   183,  -411,   170,   172,
    -411,  -411,   181,   260,  -411,    33,     6,    30,   168,  -411,
    -411,  -411,  -411,   187,  -411,  -411,  -411,  -411,  -411,  -411,
    -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,    37,
     185,   186,   124,  -411,  -411,   212,   194,  -411,  -411,   220,
     198,  -411,  -411,  -411,  -411,  -411,   184,   250,   199,   201,
      37,  -411,  -411,    45,   188,   193,   195,   202,   203,   204,
     205,   206,   207,   200,   -73,   122,  -411,    37,    37,  -411,
    -411,   -53,   190,   210,   219,  -411,   227,   228,   209,   213,
      71,   162,   214,   221,   242,   215,   222,   229,   264,   217,
     223,   168,  -411,   233,   225,   309,    37,    37,    37,   235,
      37,   237,  -411,  -411,  -411,   168,   168,   226,   226,  -411,
    -411,  -411,  -411,  -411,  -411,   124,  -411,   255,   261,  -411,
     240,   230,  -411,   231,  -411,   244,   284,  -411,  -411,   224,
     232,   236,   -67,   -38,    -3,   234,    27,   238,   -30,  -411,
    -411,  -411,  -411,    71,   162,   245,  -411,   -44,  -411,   248,
    -411,   251,   239,  -411,   326,   246,   318,   317,   149,   316,
     265,   263,  -411,  -411,    29,  -411,   277,   247,   252,   254,
     253,   256,  -411,   116,  -411,   259,   338,   266,   267,   268,
     269,   270,   271,   272,   273,   274,  -411,  -411,   275,   162,
     257,   285,   286,  -411,  -411,   258,  -411,   287,  -411,   288,
    -411,   313,   289,    87,    87,    87,   130,  -411,   342,   276,
      37,    37,    37,    37,    37,    37,   290,    37,   291,  -411,
      71,   298,   293,   311,   280,   283,  -411,  -411,   282,   288,
    -411,   299,  -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,
     166,   292,   365,    28,    40,    76,    98,   108,   111,   278,
      56,   279,  -411,    71,  -411,   294,   300,   295,   296,   303,
    -411,   357,  -411,   306,   297,   369,   367,   301,  -411,  -411,
    -411,  -411,  -411,   314,  -411,  -411,   302,   304,  -411,  -411,
    -411,   315,   305,   233,   308,   319,  -411,   320,  -411,  -411,
    -411,   307,   310,    37,    37,    37,   386,   321,   126,   168,
      73,   322,   323,  -411,   327,   391,   324,   325,   328,   388,
      37,   329,   330,    78,   331,    37,   332,   312,   106,   333,
    -411,   396,   334,    37,   335,  -411,   118,   323,   341,  -411,
     337,    37,   131,  -411
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     9,     0,    20,     4,     5,     8,     1,   207,     0,
      21,    22,     6,     0,    31,    32,     0,    28,   209,    23,
     140,    27,    15,    16,    10,    11,    12,    13,    14,     7,
      26,    24,   211,     2,   210,     0,   208,    85,    84,    25,
      33,    37,    38,    39,   107,    43,    34,     0,    35,    36,
       0,     0,     0,   141,   107,   107,    62,    66,     0,     0,
      82,   142,     0,    29,    17,    18,    19,     0,     0,     0,
      46,    63,     0,     0,     0,     0,    90,    91,    92,    87,
      89,     0,   103,    86,   104,     0,     0,     0,    82,     0,
      95,     0,     0,    30,     0,     0,     0,     0,    62,     0,
      48,    67,    88,   102,   105,     0,   108,   109,    71,    72,
       0,     0,    93,   100,   101,     0,     0,   147,     0,     0,
     170,   171,   149,   172,   143,     0,    66,     0,   145,   148,
     168,   169,   173,   150,   152,   153,   154,   155,   156,   157,
     162,   163,   164,   165,   158,   159,   167,   160,   161,     0,
       0,     0,     0,    51,    47,     0,     0,   106,    73,    78,
       0,    83,    94,    98,    97,    99,     0,   111,     0,     0,
       0,   151,   177,     0,   147,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   144,     0,     0,   172,
     174,   199,     0,     0,     0,    54,     0,     0,     0,    52,
       0,    62,     0,     0,    80,     0,     0,     0,   113,     0,
       0,   176,   178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   166,   198,   187,   146,   175,     0,   201,    44,
      45,    56,    55,    57,    50,     0,    58,     0,     0,    79,
       0,    74,    41,     0,   112,     0,   115,   179,   180,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     139,   202,    53,     0,    62,     0,    81,     0,    42,     0,
     114,     0,   117,   189,     0,     0,     0,     0,     0,     0,
       0,     0,   205,   204,     0,    59,     0,     0,     0,     0,
       0,     0,   116,     0,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   206,   203,    64,    62,
      69,     0,     0,    76,   110,     0,   127,     0,   126,     0,
     130,     0,     0,     0,   122,   122,     0,   120,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    65,
       0,     0,     0,     0,     0,     0,   119,   128,     0,   131,
     136,     0,   129,   125,   124,   132,   134,   123,   135,   118,
       0,     0,     0,     0,   195,     0,     0,     0,     0,     0,
       0,     0,    60,     0,    49,     0,     0,     0,     0,     0,
     137,     0,   121,     0,     0,     0,     0,     0,   191,   193,
     194,   192,   197,     0,   186,    61,     0,     0,    75,    77,
     138,     0,     0,     0,     0,     0,   190,     0,    70,    68,
     133,     0,     0,     0,     0,     0,     0,     0,     0,   196,
       0,     0,     0,   185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   183,     0,
     181,     0,     0,     0,     0,   182,     0,     0,     0,   184,
       0,     0,     0,   188
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -411,  -411,  -411,  -411,   410,  -411,  -411,  -411,  -411,  -411,
     397,  -411,     9,  -411,  -411,  -411,  -411,  -411,  -411,   336,
    -411,   189,  -411,  -411,  -411,  -411,  -411,   -94,  -411,   339,
    -411,  -411,  -411,  -411,  -411,  -411,  -411,   340,  -411,  -411,
    -411,  -411,  -411,  -411,  -411,   343,   366,   175,   171,  -411,
    -411,  -411,  -411,  -411,   101,   104,    69,  -411,    81,  -411,
    -411,  -411,  -411,   109,  -149,   -95,  -211,  -411,   344,  -411,
    -411,  -410,  -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,
    -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,  -411,   208,
    -411,    60,  -411,  -411,  -411
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,     5,     6,    29,     9,    10,    18,
      19,    20,    21,    39,    40,    41,    42,    43,    44,    97,
      98,   198,   199,   201,   264,   309,   374,    72,   340,    73,
     101,   343,   109,   159,   268,   204,   241,    90,    45,    82,
      83,   163,   115,   165,   116,    84,    85,    60,   167,   208,
     246,   272,   294,   326,   356,   357,   327,   349,   350,    46,
      47,    62,    92,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   442,   140,   141,   142,
     143,   144,   145,   146,   387,   147,   148,   228,   260,   259,
     284,    11,    49,    33,    34
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     191,   153,   249,    35,   155,    87,    88,   288,   289,   174,
     175,   282,   426,   117,   118,   119,   176,    99,   118,   119,
     177,   211,   -96,   178,   179,    30,   180,   227,   223,   276,
      64,    65,    66,    89,   166,   188,   117,   449,   225,   226,
     117,   118,   119,   162,    53,   118,   119,    96,    99,   188,
     283,   100,    54,    55,   112,    14,    15,    56,   277,    63,
      57,   120,   121,     1,   188,    16,    17,   252,   253,   254,
      58,   256,   113,   114,    59,   181,    93,   152,    32,     7,
      48,   182,     8,    36,   120,   121,   122,   123,   120,   121,
     122,   123,    37,   278,    58,    14,    15,    38,    59,   188,
     125,   124,    22,    23,   125,   236,   126,   237,     8,   306,
     126,   120,   121,   122,   123,   120,   121,   122,   123,   315,
     307,   186,    13,   280,   385,    51,   187,   125,   172,   188,
     188,   125,    24,   126,    25,    26,   386,   126,    27,    28,
     212,   187,   188,   316,   317,   318,   319,   320,   321,   120,
     121,   322,   393,   323,   324,   325,    50,    74,   188,    75,
      76,    77,    78,    79,    80,   353,   299,   354,   285,   424,
     286,   300,   301,   302,   436,   188,    81,   388,   188,    52,
     188,   363,   364,   365,   366,   367,   368,   194,   370,   195,
     196,   197,   412,   316,   317,   318,   319,   320,   321,   389,
     188,   322,   441,   323,   324,   325,    14,    15,   188,   390,
     188,     8,   391,   188,   448,   341,    16,    17,   187,    61,
     188,    70,   359,   224,    71,    67,   360,   423,   188,    68,
      69,    91,   453,   188,   173,   185,    94,    96,    95,   102,
     103,   104,   105,   107,   108,   372,   106,    89,   111,   150,
     151,   149,   154,    75,   156,   161,   158,   160,    71,   164,
     168,   166,   169,   171,   418,   419,   420,   170,   189,   192,
     188,   193,   202,   200,   203,   207,   205,   206,   395,   214,
     209,   433,   210,   229,   213,   215,   438,   231,   216,   217,
     218,   219,   220,   221,   446,   232,   233,   240,   245,   239,
     243,   222,   452,   230,   234,   250,   242,   244,   247,   235,
     238,   120,   251,   255,   248,   257,   258,   263,   266,   265,
     271,   269,   270,   287,   267,   273,   291,   275,   274,   292,
     279,   295,   296,   297,   281,   298,   293,   303,   304,   305,
     308,   329,   311,   310,   312,   328,   351,   314,   313,   361,
     346,   342,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   373,   344,   345,   347,   348,   352,   369,   371,
     376,   377,   362,   375,   378,   379,   384,   381,   397,   392,
     394,   400,   383,   401,   402,   404,   405,   403,   407,   396,
     398,   399,   421,   410,   413,   409,   411,   427,   408,   428,
     432,   417,   406,   416,   439,   414,   415,   422,   425,   444,
     434,   430,   450,   440,    12,    31,   435,   125,   431,   443,
     429,   447,   437,   451,   262,    86,   358,   355,   110,   382,
     380,     0,     0,     0,     0,   445,   261,     0,   290,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   183,     0,     0,   184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   190
};

static const yytype_int16 yycheck[] =
{
     149,    96,   213,     3,    98,    50,    51,    51,    52,     3,
       4,    41,   422,     3,     8,     9,    10,    90,     8,     9,
      14,   170,    77,    17,    18,    16,    20,    80,   101,    96,
      80,    81,    82,    78,    78,   102,     3,   447,   187,   188,
       3,     8,     9,    98,    35,     8,     9,    41,    90,   102,
      80,    93,    48,    49,    80,    77,    78,    53,    96,    50,
      56,    78,    79,    60,   102,    87,    88,   216,   217,   218,
      90,   220,    98,    99,    94,    69,    67,    94,    18,     0,
      20,    75,    82,    83,    78,    79,    80,    81,    78,    79,
      80,    81,    92,    96,    90,    77,    78,    97,    94,   102,
      94,    91,    48,    49,    94,   200,   100,   201,    82,    80,
     100,    78,    79,    80,    81,    78,    79,    80,    81,     3,
      91,    91,    86,    96,    96,    86,    96,    94,    95,   102,
     102,    94,    78,   100,    80,    81,    96,   100,    84,    85,
      95,    96,   102,    27,    28,    29,    30,    31,    32,    78,
      79,    35,    96,    37,    38,    39,    89,    40,   102,    42,
      43,    44,    45,    46,    47,    78,    17,    80,   263,    96,
     264,    22,    23,    24,    96,   102,    59,   101,   102,    89,
     102,   330,   331,   332,   333,   334,   335,    63,   337,    65,
      66,    67,   403,    27,    28,    29,    30,    31,    32,   101,
     102,    35,    96,    37,    38,    39,    77,    78,   102,   101,
     102,    82,   101,   102,    96,   309,    87,    88,    96,    80,
     102,    93,    92,   101,    96,    87,    96,   101,   102,    54,
      55,    90,   101,   102,   125,   126,    84,    41,    85,    79,
      79,    78,    96,    95,    80,   340,    91,    78,    92,    92,
      92,    86,    93,    42,    57,    78,    80,    90,    96,    77,
      90,    78,    90,     3,   413,   414,   415,    86,    81,    84,
     102,    85,    78,    61,    54,    25,    78,    93,   373,    86,
      81,   430,    81,    93,    96,    90,   435,    68,    86,    86,
      86,    86,    86,    86,   443,    68,    68,    55,    34,    78,
      78,   101,   451,    93,    95,    80,    91,    78,    91,    96,
      96,    78,     3,    78,    91,    78,    90,    62,    78,    58,
      36,    90,    78,    78,    94,   101,    78,    91,    96,    78,
      96,     5,    86,    15,    96,    18,    97,    21,    73,    76,
      63,     3,    90,    96,    90,    86,    33,    91,    95,     7,
      92,    94,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    86,    64,    78,    78,    78,    78,    78,    78,    78,
      59,    91,    96,    80,    91,    93,    11,    78,    78,   101,
     101,    78,    90,    26,    78,    16,    19,    90,    74,    95,
      95,    95,     6,    78,    86,    91,    91,    70,    96,     8,
      12,    91,   101,    96,    72,    86,    86,    86,    86,    13,
      81,    86,    71,   101,     4,    18,    86,    94,    90,    86,
      96,    86,    91,    86,   235,    59,   325,   323,    88,   360,
     349,    -1,    -1,    -1,    -1,   101,   228,    -1,   267,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   126,    -1,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    60,   104,   105,   106,   107,   108,     0,    82,   110,
     111,   194,   107,    86,    77,    78,    87,    88,   112,   113,
     114,   115,    48,    49,    78,    80,    81,    84,    85,   109,
     115,   113,   194,   196,   197,     3,    83,    92,    97,   116,
     117,   118,   119,   120,   121,   141,   162,   163,   194,   195,
      89,    86,    89,   115,    48,    49,    53,    56,    90,    94,
     150,    80,   164,   115,    80,    81,    82,    87,   150,   150,
      93,    96,   130,   132,    40,    42,    43,    44,    45,    46,
      47,    59,   142,   143,   148,   149,   149,    50,    51,    78,
     140,    90,   165,   115,    84,    85,    41,   122,   123,    90,
      93,   133,    79,    79,    78,    96,    91,    95,    80,   135,
     140,    92,    80,    98,    99,   145,   147,     3,     8,     9,
      78,    79,    80,    81,    91,    94,   100,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     180,   181,   182,   183,   184,   185,   186,   188,   189,    86,
      92,    92,    94,   168,    93,   130,    57,   148,    80,   136,
      90,    78,    98,   144,    77,   146,    78,   151,    90,    90,
      86,     3,    95,   166,     3,     4,    10,    14,    17,    18,
      20,    69,    75,   122,   132,   166,    91,    96,   102,    81,
     171,   167,    84,    85,    63,    65,    66,    67,   124,   125,
      61,   126,    78,    54,   138,    78,    93,    25,   152,    81,
      81,   167,    95,    96,    86,    90,    86,    86,    86,    86,
      86,    86,   101,   101,   101,   167,   167,    80,   190,    93,
      93,    68,    68,    68,    95,    96,   168,   130,    96,    78,
      55,   139,    91,    78,    78,    34,   153,    91,    91,   169,
      80,     3,   167,   167,   167,    78,   167,    78,    90,   192,
     191,   192,   124,    62,   127,    58,    78,    94,   137,    90,
      78,    36,   154,   101,    96,    91,    96,    96,    96,    96,
      96,    96,    41,    80,   193,   168,   130,    78,    51,    52,
     151,    78,    78,    97,   155,     5,    86,    15,    18,    17,
      22,    23,    24,    21,    73,    76,    80,    91,    63,   128,
      96,    90,    90,    95,    91,     3,    27,    28,    29,    30,
      31,    32,    35,    37,    38,    39,   156,   159,    86,     3,
      86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
     131,   130,    94,   134,    78,    78,    92,    78,    78,   160,
     161,    33,    78,    78,    80,   158,   157,   158,   157,    92,
      96,     7,    96,   167,   167,   167,   167,   167,   167,    78,
     167,    78,   168,    64,   129,    80,    59,    91,    91,    93,
     161,    78,   159,    90,    11,    96,    96,   187,   101,   101,
     101,   101,   101,    96,   101,   168,    95,    78,    95,    95,
      78,    26,    78,    90,    16,    19,   101,    74,    96,    91,
      78,    91,   169,    86,    86,    86,    96,    91,   167,   167,
     167,     6,    86,   101,    96,    86,   174,    70,     8,    96,
      86,    90,    12,   167,    81,    86,    96,    91,   167,    72,
     101,    96,   179,    86,    13,   101,   167,    86,    96,   174,
      71,    86,   167,   101
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   103,   104,   105,   105,   106,   106,   107,   107,   108,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     110,   110,   111,   112,   112,   113,   114,   114,   114,   114,
     114,   115,   115,   116,   116,   116,   116,   117,   117,   117,
     118,   119,   120,   121,   121,   121,   121,   121,   121,   122,
     123,   123,   124,   124,   125,   125,   125,   125,   126,   127,
     128,   129,   130,   130,   131,   131,   132,   132,   133,   134,
     134,   135,   136,   136,   137,   137,   137,   137,   138,   138,
     139,   139,   140,   140,   141,   141,   142,   142,   142,   143,
     143,   143,   143,   144,   144,   145,   145,   146,   147,   147,
     147,   147,   148,   149,   149,   149,   149,   150,   150,   150,
     151,   152,   152,   153,   153,   154,   154,   155,   155,   155,
     156,   156,   157,   157,   158,   158,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   160,   160,   161,   162,
     163,   163,   164,   165,   165,   166,   166,   167,   167,   167,
     167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
     167,   167,   167,   167,   167,   167,   167,   167,   168,   168,
     169,   170,   171,   172,   172,   173,   173,   174,   174,   175,
     176,   177,   178,   179,   179,   180,   181,   182,   183,   184,
     185,   186,   186,   186,   186,   187,   187,   188,   189,   190,
     190,   191,   191,   192,   193,   193,   193,   194,   195,   196,
     196,   197
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     4,     0,     1,     1,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       0,     1,     1,     1,     2,     2,     2,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       9,     7,     8,     1,     7,     7,     3,     5,     4,     9,
       4,     2,     1,     3,     1,     2,     2,     2,     2,     2,
       3,     2,     0,     1,     0,     1,     0,     2,    11,     0,
       4,     1,     0,     1,     0,     6,     3,     6,     0,     2,
       0,     2,     0,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     0,     1,     0,     1,     1,     2,     2,
       1,     1,     2,     1,     1,     2,     3,     0,     3,     3,
       6,     0,     2,     0,     2,     0,     2,     0,     3,     3,
       1,     3,     0,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     2,     5,     2,     2,     1,     2,     3,     7,
       0,     2,     1,     2,     3,     1,     3,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     3,     4,
       4,    19,    20,     0,     4,    13,     9,     3,    25,     5,
      10,     9,     9,     9,     9,     0,     4,     9,     3,     0,
       2,     0,     1,     3,     1,     1,     2,     1,     1,     0,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 601 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = NULL;		/* The parser output is in out_script */
}
#line 2270 "parser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 607 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = NULL;
	parse_and_finalize_config(invocation);
}
#line 2279 "parser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 611 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = (yyvsp[0].option);
	parse_and_finalize_config(invocation);
}
#line 2288 "parser.c" /* yacc.c:1646  */
    break;

  case 5:
#line 618 "parser.y" /* yacc.c:1646  */
    {
	out_script->option_list = (yyvsp[0].option);
	(yyval.option) = (yyvsp[0].option);		/* return the tail so we can append to it */
}
#line 2297 "parser.c" /* yacc.c:1646  */
    break;

  case 6:
#line 622 "parser.y" /* yacc.c:1646  */
    {
	(yyvsp[-1].option)->next = (yyvsp[0].option);
	(yyval.option) = (yyvsp[0].option);		/* return the tail so we can append to it */
}
#line 2306 "parser.c" /* yacc.c:1646  */
    break;

  case 7:
#line 629 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = new_option((yyvsp[-2].string), (yyvsp[0].string));
}
#line 2314 "parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 632 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = new_option((yyvsp[0].string), NULL);
}
#line 2322 "parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 637 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].reserved); }
#line 2328 "parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 641 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(yytext); }
#line 2334 "parser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 642 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2340 "parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 643 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2346 "parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 644 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2352 "parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 645 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2358 "parser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 646 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("ipv4"); }
#line 2364 "parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 647 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("ipv6"); }
#line 2370 "parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 648 "parser.y" /* yacc.c:1646  */
    {
	/* For consistency, allow syntax like: --define=PROTO=IPPROTO_TCP */
	char *lhs = (yyvsp[-2].string), *rhs = (yyvsp[0].string);

	asprintf(&((yyval.string)), "%s=%s", lhs, rhs);
	free(lhs);
	free(rhs);
}
#line 2383 "parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 656 "parser.y" /* yacc.c:1646  */
    {
	/* For consistency, allow syntax like: --define=CC="reno" */
	char *lhs = (yyvsp[-2].string), *rhs = (yyvsp[0].string);

	asprintf(&((yyval.string)), "%s=\"%s\"", lhs, rhs);
	free(lhs);
	free(rhs);
}
#line 2396 "parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 664 "parser.y" /* yacc.c:1646  */
    {
	/* For consistency, allow syntax like: --define=SCRIPT=`cleanup` */
	char *lhs = (yyvsp[-2].string), *rhs = (yyvsp[0].string);

	asprintf(&((yyval.string)), "%s=`%s`", lhs, rhs);
	free(lhs);
	free(rhs);
}
#line 2409 "parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 675 "parser.y" /* yacc.c:1646  */
    { }
#line 2415 "parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 676 "parser.y" /* yacc.c:1646  */
    { }
#line 2421 "parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 680 "parser.y" /* yacc.c:1646  */
    { out_script->init_command = (yyvsp[0].command); }
#line 2427 "parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 684 "parser.y" /* yacc.c:1646  */
    {
	out_script->event_list = (yyvsp[0].event);  /* save pointer to event list as output
				       * of parser */
	(yyval.event) = (yyvsp[0].event);          /* return the tail so that we can append to it */
}
#line 2437 "parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 689 "parser.y" /* yacc.c:1646  */
    {
	(yyvsp[-1].event)->next = (yyvsp[0].event);    /* link new event to the end of the existing list */
	(yyval.event) = (yyvsp[0].event);          /* return the tail so that we can append to it */
}
#line 2446 "parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 696 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = (yyvsp[0].event);
	(yyval.event)->line_number = (yyvsp[-1].event)->line_number;   /* use timestamp's line */
	(yyval.event)->time_usecs  = (yyvsp[-1].event)->time_usecs;
	(yyval.event)->time_usecs_end  = (yyvsp[-1].event)->time_usecs_end;
	(yyval.event)->time_type = (yyvsp[-1].event)->time_type;

	if ((yyval.event)->time_usecs_end != NO_TIME_RANGE) {
		if ((yyval.event)->time_usecs_end < (yyval.event)->time_usecs)
			semantic_error("time range is backwards");
	}
	if ((yyval.event)->time_type == ANY_TIME &&  ((yyval.event)->type != PACKET_EVENT ||
	    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time <star> can only be used with "
			       "outbound packets");
	} else if (((yyval.event)->time_type == ABSOLUTE_RANGE_TIME ||
		    (yyval.event)->time_type == RELATIVE_RANGE_TIME) &&
	           ((yyval.event)->type != PACKET_EVENT ||
		    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time range can only be used with "
			       "outbound packets");
	}
	free((yyvsp[-1].event));
}
#line 2477 "parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 725 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_usecs = (yyvsp[0].time_usecs);
	(yyval.event)->time_type = RELATIVE_TIME;
}
#line 2488 "parser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 731 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_usecs = (yyvsp[0].time_usecs);
	(yyval.event)->time_type = ABSOLUTE_TIME;
}
#line 2499 "parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 737 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_type = ANY_TIME;
}
#line 2509 "parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 742 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[-2]).first_line;
	(yyval.event)->time_type = ABSOLUTE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[-2].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[0].time_usecs);
}
#line 2521 "parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 749 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[-4]).first_line;
	(yyval.event)->time_type = RELATIVE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[-3].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[0].time_usecs);
}
#line 2533 "parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 759 "parser.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].floating) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[0].floating) * 1.0e6); /* convert float secs to s64 microseconds */
}
#line 2544 "parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 765 "parser.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].integer) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[0].integer) * 1000000); /* convert int secs to s64 microseconds */
}
#line 2555 "parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 774 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(PACKET_EVENT);  (yyval.event)->event.packet  = (yyvsp[0].packet); }
#line 2561 "parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 775 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(SYSCALL_EVENT); (yyval.event)->event.syscall = (yyvsp[0].syscall); }
#line 2567 "parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 776 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(COMMAND_EVENT); (yyval.event)->event.command = (yyvsp[0].command); }
#line 2573 "parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 777 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(CODE_EVENT);    (yyval.event)->event.code    = (yyvsp[0].code); }
#line 2579 "parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 781 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2585 "parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 782 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2591 "parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 783 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2597 "parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 787 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-8].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (((yyvsp[-7].ip_info).tos.check == TOS_CHECK_ECN_ECT01) &&
	    (direction != DIRECTION_OUTBOUND)) {
		semantic_error("[ect01] can only be used with outbound packets");
	}

	if (((yyvsp[0].tcp_options) == NULL) && (direction != DIRECTION_OUTBOUND)) {
		yylineno = (yylsp[-2]).first_line;
		semantic_error("<...> for TCP options can only be used with "
			       "outbound packets");
	}

	inner = new_tcp_packet(in_config->wire_protocol,
			       direction, (yyvsp[-7].ip_info), (yyvsp[-6].port_info).src_port, (yyvsp[-6].port_info).dst_port, (yyvsp[-5].string),
			       (yyvsp[-4].tcp_sequence_info).start_sequence, (yyvsp[-4].tcp_sequence_info).payload_bytes,
			       (yyvsp[-3].sequence_number), (yyvsp[-2].window), (yyvsp[-1].urg_ptr), (yyvsp[0].tcp_options), &error);
	free((yyvsp[-5].string));
	free((yyvsp[0].tcp_options));
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2632 "parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 820 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-6].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if ((yyvsp[-5].ip_info).tos.check == TOS_CHECK_ECN) {
		semantic_error("ECN can only be used with TCP packets");
	}

	if (!is_valid_u16((yyvsp[-1].integer))) {
		semantic_error("UDP payload size out of range");
	}

	inner = new_udp_packet(in_config->wire_protocol, direction, (yyvsp[-5].ip_info),
			       (yyvsp[-1].integer), (yyvsp[-3].port_info).src_port, (yyvsp[-3].port_info).dst_port, &error);
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2660 "parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 847 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-7].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (((yyvsp[-6].ip_info).tos.check == TOS_CHECK_ECN_ECT01) &&
	    (direction != DIRECTION_OUTBOUND)) {
		semantic_error("[ect01] can only be used with outbound packets");
	}

	inner = new_icmp_packet(in_config->wire_protocol, direction, (yyvsp[-4].string), (yyvsp[-3].string),
				(yyvsp[0].tcp_sequence_info).protocol, (yyvsp[0].tcp_sequence_info).start_sequence,
				(yyvsp[0].tcp_sequence_info).payload_bytes, (yyvsp[-6].ip_info), (yyvsp[-2].integer), (yyvsp[-1].integer), &error);
	free((yyvsp[-4].string));
	free((yyvsp[-3].string));
	if (inner == NULL) {
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2687 "parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 873 "parser.y" /* yacc.c:1646  */
    {
	(yyval.packet) = packet_new(PACKET_MAX_HEADER_BYTES);
	(yyval.packet)->direction = (yyvsp[0].direction);
}
#line 2696 "parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 877 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-6].packet);
	u8 tos = (yyvsp[-4].ip_info).tos.value;
	u8 ttl = (yyvsp[-4].ip_info).ttl;
	char *ip_src = (yyvsp[-3].string);
	char *ip_dst = (yyvsp[-1].string);
	if (ipv4_header_append(packet, ip_src, ip_dst, tos, ttl, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
#line 2714 "parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 890 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-6].packet);
	u8 tos = (yyvsp[-4].ip_info).tos.value;
	u8 hop_limit = (yyvsp[-4].ip_info).ttl;
	char *ip_src = (yyvsp[-3].string);
	char *ip_dst = (yyvsp[-1].string);
	if (ipv6_header_append(packet, ip_src, ip_dst, tos, hop_limit, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
#line 2732 "parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 903 "parser.y" /* yacc.c:1646  */
    {
	struct packet *packet = (yyvsp[-2].packet);
	struct expression *expr = new_expression(EXPR_GRE);
	(yyval.packet) = append_gre(packet, expr);
}
#line 2742 "parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 908 "parser.y" /* yacc.c:1646  */
    {
	struct packet *packet = (yyvsp[-4].packet);
	struct expression *expr = (yyvsp[-1].expression);
	(yyval.packet) = append_gre(packet, expr);
}
#line 2752 "parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 913 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-3].packet);
	struct mpls_stack *mpls_stack = (yyvsp[-1].mpls_stack);

	if (mpls_header_append(packet, mpls_stack, &error))
		semantic_error(error);
	free(mpls_stack);
	(yyval.packet) = packet;
}
#line 2767 "parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 930 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_GRE);
	(yyval.expression)->value.gre.flags = htons((yyvsp[-8].integer));
	(yyval.expression)->value.gre.be16[0] = htons((yyvsp[-6].integer));
	(yyval.expression)->value.gre.be16[1] = htons((yyvsp[-4].integer));
	(yyval.expression)->value.gre.be32[1] = htonl((yyvsp[-2].integer));
	(yyval.expression)->value.gre.be32[2] = htonl((yyvsp[0].integer));
}
#line 2780 "parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 941 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[-1].integer); }
#line 2786 "parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 942 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].expression)->value.num; }
#line 2792 "parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 946 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].integer); }
#line 2798 "parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 947 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[-2].integer) | (yyvsp[0].integer); }
#line 2804 "parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 951 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 2810 "parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 952 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = GRE_FLAG_C; }
#line 2816 "parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 953 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = GRE_FLAG_K; }
#line 2822 "parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 954 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = GRE_FLAG_S; }
#line 2828 "parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 958 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].expression)->value.num; }
#line 2834 "parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 962 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].expression)->value.num; }
#line 2840 "parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 966 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].expression)->value.num; }
#line 2846 "parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 970 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].expression)->value.num; }
#line 2852 "parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 974 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2858 "parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 975 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2864 "parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 979 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2870 "parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 980 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2876 "parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 984 "parser.y" /* yacc.c:1646  */
    {
	(yyval.mpls_stack) = mpls_stack_new();
}
#line 2884 "parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 987 "parser.y" /* yacc.c:1646  */
    {
	if (mpls_stack_append((yyvsp[-1].mpls_stack), (yyvsp[0].mpls_stack_entry)))
		semantic_error("too many MPLS labels");
	(yyval.mpls_stack) = (yyvsp[-1].mpls_stack);
}
#line 2894 "parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 996 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	s64 label = (yyvsp[-8].integer);
	s64 traffic_class = (yyvsp[-5].integer);
	bool is_stack_bottom = (yyvsp[-3].integer);
	s64 ttl = (yyvsp[-1].integer);
	struct mpls mpls;

	if (new_mpls_stack_entry(label, traffic_class, is_stack_bottom, ttl,
				 &mpls, &error))
		semantic_error(error);
	(yyval.mpls_stack_entry) = mpls;
}
#line 2912 "parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1012 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 2918 "parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1013 "parser.y" /* yacc.c:1646  */
    {
	if (strcmp((yyvsp[-2].string), "S") != 0)
		semantic_error("expected [S] for MPLS label stack bottom");
	free((yyvsp[-2].string));
	(yyval.integer) = 1;
}
#line 2929 "parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1022 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2935 "parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1026 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2941 "parser.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1027 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2947 "parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1032 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= 0;
	(yyval.tcp_sequence_info).protocol		= IPPROTO_TCP;
}
#line 2957 "parser.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1037 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= (yyvsp[-2].integer);
	(yyval.tcp_sequence_info).protocol		= IPPROTO_UDP;
}
#line 2967 "parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1042 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info) = (yyvsp[-1].tcp_sequence_info);
}
#line 2975 "parser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1045 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info).payload_bytes        = (yyvsp[-2].integer);
	(yyval.tcp_sequence_info).protocol             = IPPROTO_RAW;
}
#line 2984 "parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1052 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = -1; }
#line 2990 "parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1053 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].integer); }
#line 2996 "parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1057 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 3002 "parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1058 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].integer); }
#line 3008 "parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1062 "parser.y" /* yacc.c:1646  */
    {
	(yyval.port_info).src_port		= 0;
	(yyval.port_info).dst_port		= 0;
}
#line 3017 "parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1066 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u16((yyvsp[-2].integer))) {
		semantic_error("src port out of range");
	}
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("dst port out of range");
	}

	(yyval.port_info).src_port		= (yyvsp[-2].integer);
	(yyval.port_info).dst_port		= (yyvsp[0].integer);
}
#line 3033 "parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1080 "parser.y" /* yacc.c:1646  */
    { (yyval.direction) = DIRECTION_INBOUND;  current_script_line = yylineno; }
#line 3039 "parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1081 "parser.y" /* yacc.c:1646  */
    { (yyval.direction) = DIRECTION_OUTBOUND; current_script_line = yylineno; }
#line 3045 "parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1085 "parser.y" /* yacc.c:1646  */
    { (yyval.tos_spec).check = TOS_CHECK_ECN; (yyval.tos_spec).value = (yyvsp[0].ip_ecn); }
#line 3051 "parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1086 "parser.y" /* yacc.c:1646  */
    { (yyval.tos_spec).check = TOS_CHECK_ECN_ECT01; (yyval.tos_spec).value = 0; }
#line 3057 "parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1087 "parser.y" /* yacc.c:1646  */
    {
	s64 tos = (yyvsp[0].integer);

	if (!is_valid_u8(tos)) {
		semantic_error("tos out of range for 8 bits");
	}

	(yyval.tos_spec).check = TOS_CHECK_TOS;
	(yyval.tos_spec).value = tos;
}
#line 3072 "parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1100 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = IP_ECN_NONE; }
#line 3078 "parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1101 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = IP_ECN_ECT0; }
#line 3084 "parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1102 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = IP_ECN_ECT1; }
#line 3090 "parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1103 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = IP_ECN_CE; }
#line 3096 "parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1107 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = strdup("");
}
#line 3104 "parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1110 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = strdup(".");
}
#line 3112 "parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1116 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = strdup("");
}
#line 3120 "parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1119 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = (yyvsp[0].string);
}
#line 3128 "parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1125 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = strdup(yytext);
}
#line 3136 "parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1131 "parser.y" /* yacc.c:1646  */
    { asprintf(&((yyval.string)), "%s%s", (yyvsp[-1].string), (yyvsp[0].string)); free((yyvsp[-1].string)); free((yyvsp[0].string)); }
#line 3142 "parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1132 "parser.y" /* yacc.c:1646  */
    { asprintf(&((yyval.string)), "%s%s", (yyvsp[-1].string), (yyvsp[0].string)); free((yyvsp[-1].string)); free((yyvsp[0].string)); }
#line 3148 "parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1133 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("."); }
#line 3154 "parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1134 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 3160 "parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1138 "parser.y" /* yacc.c:1646  */
    {
	s64 flowlabel = (yyvsp[0].integer);

	if (!is_valid_u20(flowlabel)) {
		semantic_error("flowlabel out of range for 20 bits");
	}
	(yyval.integer) = flowlabel;
}
#line 3173 "parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1149 "parser.y" /* yacc.c:1646  */
    {
	(yyval.ip_info).tos.check = (yyvsp[0].tos_spec).check;
	(yyval.ip_info).tos.value = (yyvsp[0].tos_spec).value;
	(yyval.ip_info).flow_label = 0;
	(yyval.ip_info).ttl = 0;
}
#line 3184 "parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1155 "parser.y" /* yacc.c:1646  */
    {
	(yyval.ip_info).tos.check = TOS_CHECK_NONE;
	(yyval.ip_info).tos.value = 0;
	(yyval.ip_info).flow_label = (yyvsp[0].integer);
	(yyval.ip_info).ttl = 0;
}
#line 3195 "parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1161 "parser.y" /* yacc.c:1646  */
    {
	(yyval.ip_info).tos.check = TOS_CHECK_NONE;
	(yyval.ip_info).tos.value = 0;
	(yyval.ip_info).flow_label = 0;
	(yyval.ip_info).ttl = (yyvsp[0].integer);
}
#line 3206 "parser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1167 "parser.y" /* yacc.c:1646  */
    {
	(yyval.ip_info).tos.check = (yyvsp[-2].tos_spec).check;
	(yyval.ip_info).tos.value = (yyvsp[-2].tos_spec).value;
	(yyval.ip_info).flow_label = (yyvsp[0].integer);
	(yyval.ip_info).ttl = 0;
}
#line 3217 "parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1176 "parser.y" /* yacc.c:1646  */
    {
	(yyval.ip_info).tos.check = TOS_CHECK_NONE;
	(yyval.ip_info).tos.value = 0;
	(yyval.ip_info).flow_label = 0;
	(yyval.ip_info).ttl = 0;
}
#line 3228 "parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1182 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_info) = (yyvsp[-1].ip_info); }
#line 3234 "parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1183 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_info) = (yyvsp[-1].ip_info); }
#line 3240 "parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1187 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u32((yyvsp[-5].integer))) {
		semantic_error("TCP start sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[-3].integer))) {
		semantic_error("TCP end sequence number out of range");
	}
	if (!is_valid_u16((yyvsp[-1].integer))) {
		semantic_error("TCP payload size out of range");
	}
	if ((yyvsp[-3].integer) != ((yyvsp[-5].integer) +(yyvsp[-1].integer))) {
		semantic_error("inconsistent TCP sequence numbers and "
			       "payload size");
	}
	(yyval.tcp_sequence_info).start_sequence = (yyvsp[-5].integer);
	(yyval.tcp_sequence_info).payload_bytes = (yyvsp[-1].integer);
	(yyval.tcp_sequence_info).protocol = IPPROTO_TCP;
}
#line 3263 "parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1208 "parser.y" /* yacc.c:1646  */
    { (yyval.sequence_number) = 0; }
#line 3269 "parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1209 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("TCP ack sequence number out of range");
	}
	(yyval.sequence_number) = (yyvsp[0].integer);
}
#line 3280 "parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1218 "parser.y" /* yacc.c:1646  */
    { (yyval.window) = -1; }
#line 3286 "parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1219 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("TCP window value out of range");
	}
	(yyval.window) = (yyvsp[0].integer);
}
#line 3297 "parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1228 "parser.y" /* yacc.c:1646  */
    { (yyval.urg_ptr) = 0; }
#line 3303 "parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1229 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("urg_ptr value out of range");
	}
	(yyval.urg_ptr) = (yyvsp[0].integer);
}
#line 3314 "parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1238 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = tcp_options_new(); }
#line 3320 "parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1239 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = (yyvsp[-1].tcp_options); }
#line 3326 "parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1240 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = NULL; /* FLAG_OPTIONS_NOCHECK */ }
#line 3332 "parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1244 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_options) = tcp_options_new();
	if (tcp_options_append((yyval.tcp_options), (yyvsp[0].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
#line 3343 "parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1250 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_options) = (yyvsp[-2].tcp_options);
	if (tcp_options_append((yyval.tcp_options), (yyvsp[0].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
#line 3354 "parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1259 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 3360 "parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1260 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3366 "parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1264 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3372 "parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1265 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(yytext); }
#line 3378 "parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1269 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_NOP, 1); }
#line 3384 "parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1270 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_EOL, 1); }
#line 3390 "parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1271 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_MAXSEG, TCPOLEN_MAXSEG);
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("mss value out of range");
	}
	(yyval.tcp_option)->data.mss.bytes = htons((yyvsp[0].integer));
}
#line 3402 "parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1278 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_WINDOW, TCPOLEN_WINDOW);
	if (!is_valid_u8((yyvsp[0].integer))) {
		semantic_error("window scale shift count out of range");
	}
	(yyval.tcp_option)->data.window_scale.shift_count = (yyvsp[0].integer);
}
#line 3414 "parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1285 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK_PERMITTED,
				    TCPOLEN_SACK_PERMITTED);
}
#line 3423 "parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1289 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = (yyvsp[0].tcp_option);
}
#line 3431 "parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1292 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	(yyval.tcp_option) = new_md5_option((yyvsp[0].string), &error);
	free((yyvsp[0].string));
	if ((yyval.tcp_option) == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}
}
#line 3446 "parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1302 "parser.y" /* yacc.c:1646  */
    {
	u32 val, ecr;
	(yyval.tcp_option) = tcp_option_new(TCPOPT_TIMESTAMP, TCPOLEN_TIMESTAMP);
	if (!is_valid_u32((yyvsp[-2].integer))) {
		semantic_error("ts val out of range");
	}
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("ecr val out of range");
	}
	val = (yyvsp[-2].integer);
	ecr = (yyvsp[0].integer);
	(yyval.tcp_option)->data.time_stamp.val = htonl(val);
	(yyval.tcp_option)->data.time_stamp.ecr = htonl(ecr);
}
#line 3465 "parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1316 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	(yyval.tcp_option) = new_tcp_fast_open_option((yyvsp[0].string), &error, false);
	free((yyvsp[0].string));
	if ((yyval.tcp_option) == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}
}
#line 3480 "parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1326 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	(yyval.tcp_option) = new_tcp_fast_open_option((yyvsp[0].string), &error, true);
	free((yyvsp[0].string));
	if ((yyval.tcp_option) == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}
}
#line 3495 "parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1339 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = (yyvsp[0].tcp_option); }
#line 3501 "parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1340 "parser.y" /* yacc.c:1646  */
    {
	const int list_block_bytes =  (yyvsp[-1].tcp_option)->length - 2;
	assert(list_block_bytes > 0);
	assert((list_block_bytes % sizeof(struct sack_block)) == 0);
	const int num_blocks = list_block_bytes / sizeof(struct sack_block);
	/* Append this SACK block to the end of the array of blocks. */
	memcpy((yyvsp[-1].tcp_option)->data.sack.block + num_blocks, (yyvsp[0].tcp_option)->data.sack.block,
		sizeof(struct sack_block));
	(yyvsp[-1].tcp_option)->length += sizeof(struct sack_block);
	free((yyvsp[0].tcp_option));
	(yyval.tcp_option) = (yyvsp[-1].tcp_option);
}
#line 3518 "parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1355 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK, 2 + sizeof(struct sack_block));
	if (!is_valid_u32((yyvsp[-2].integer))) {
		semantic_error("TCP SACK left sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("TCP SACK right sequence number out of range");
	}
	(yyval.tcp_option)->data.sack.block[0].left = htonl((yyvsp[-2].integer));
	(yyval.tcp_option)->data.sack.block[0].right = htonl((yyvsp[0].integer));
}
#line 3534 "parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1370 "parser.y" /* yacc.c:1646  */
    {
	(yyval.syscall) = calloc(1, sizeof(struct syscall_spec));
	(yyval.syscall)->end_usecs	= (yyvsp[-6].time_usecs);
	(yyval.syscall)->name	= (yyvsp[-5].string);
	(yyval.syscall)->arguments	= (yyvsp[-4].expression_list);
	(yyval.syscall)->result	= (yyvsp[-2].expression);
	(yyval.syscall)->error	= (yyvsp[-1].errno_info);
	(yyval.syscall)->note	= (yyvsp[0].string);
}
#line 3548 "parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1382 "parser.y" /* yacc.c:1646  */
    { (yyval.time_usecs) = SYSCALL_NON_BLOCKING; }
#line 3554 "parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1383 "parser.y" /* yacc.c:1646  */
    { (yyval.time_usecs) = (yyvsp[0].time_usecs); }
#line 3560 "parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1387 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); current_script_line = yylineno; }
#line 3566 "parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1391 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = NULL; }
#line 3572 "parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1392 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = (yyvsp[-1].expression_list); }
#line 3578 "parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1396 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = new_expression_list((yyvsp[0].expression)); }
#line 3584 "parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1397 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = (yyvsp[-2].expression_list); expression_list_append((yyvsp[-2].expression_list), (yyvsp[0].expression)); }
#line 3590 "parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1401 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_ELLIPSIS);
}
#line 3598 "parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1404 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 3604 "parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1405 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_WORD);
	(yyval.expression)->value.buf.ptr = (yyvsp[0].string);
	(yyval.expression)->value.buf.len = strlen((yyvsp[0].string));
}
#line 3614 "parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1410 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3622 "parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1413 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.buf.ptr = (yyvsp[-1].string);
	(yyval.expression)->value.buf.len = strlen((yyvsp[-1].string));
	(yyval.expression)->format = "\"%s\"...";
}
#line 3633 "parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1419 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3641 "parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1422 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3649 "parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1425 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3657 "parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1428 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3665 "parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1431 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3673 "parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1434 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3681 "parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1437 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3689 "parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1440 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3697 "parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1443 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3705 "parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1446 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3713 "parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1449 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3721 "parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1452 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3729 "parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1455 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3737 "parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1458 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3745 "parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1461 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[-1].expression);
}
#line 3753 "parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1464 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3761 "parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1470 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 3767 "parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1471 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 3773 "parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1475 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_integer_expression((yyvsp[0].integer), "%ld");
}
#line 3781 "parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1481 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_integer_expression((yyvsp[0].integer), "%#lx");
}
#line 3789 "parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1487 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.buf.ptr = (yyvsp[0].string);
	(yyval.expression)->value.buf.len = strlen((yyvsp[0].string));
	(yyval.expression)->format = "\"%s\"";
}
#line 3800 "parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1496 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3808 "parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1499 "parser.y" /* yacc.c:1646  */
    {    /* string concatenation */
	(yyval.expression) = new_expression(EXPR_BINARY);
	struct binary_expression *binary =
			  malloc(sizeof(struct binary_expression));
	binary->op = strdup(".");
	binary->lhs = (yyvsp[-1].expression);
	binary->rhs = (yyvsp[0].expression);
	(yyval.expression)->value.binary = binary;
}
#line 3822 "parser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1511 "parser.y" /* yacc.c:1646  */
    {       /* bitwise OR */
	(yyval.expression) = new_expression(EXPR_BINARY);
	struct binary_expression *binary =
			  malloc(sizeof(struct binary_expression));
	binary->op = strdup("|");
	binary->lhs = (yyvsp[-2].expression);
	binary->rhs = (yyvsp[0].expression);
	(yyval.expression)->value.binary = binary;
}
#line 3836 "parser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1520 "parser.y" /* yacc.c:1646  */
    {       /* symbol = value */
	(yyval.expression) = new_expression(EXPR_BINARY);
	struct binary_expression *binary =
			  malloc(sizeof(struct binary_expression));
	binary->op = strdup("=");
	binary->lhs = new_expression(EXPR_WORD);
	binary->lhs->value.buf.ptr = (yyvsp[-2].string);
	binary->lhs->value.buf.len = strlen((yyvsp[-2].string));
	binary->rhs = (yyvsp[0].expression);
	(yyval.expression)->value.binary = binary;
}
#line 3852 "parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1534 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = NULL;
}
#line 3861 "parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1538 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = (yyvsp[-1].expression_list);
}
#line 3870 "parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1545 "parser.y" /* yacc.c:1646  */
    {
	__be32 ip_address = inet_addr((yyvsp[-1].string));
	(yyval.expression) = new_integer_expression(ip_address, "%#lx");
}
#line 3879 "parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1552 "parser.y" /* yacc.c:1646  */
    {
	struct in6_addr ipv6_address;
	if (inet_pton(AF_INET6, (yyvsp[-1].string), &ipv6_address) != 1) {
		semantic_error("cannot parse in6_addr");
	}
	(yyval.expression) = new_expression(EXPR_IN6_ADDR);
	(yyval.expression)->value.address_ipv6 = ipv6_address;
}
#line 3892 "parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1565 "parser.y" /* yacc.c:1646  */
    {
	if (strcmp((yyvsp[-15].string), "AF_INET") == 0) {
		struct sockaddr_in *ipv4 = malloc(sizeof(struct sockaddr_in));
		memset(ipv4, 0, sizeof(*ipv4));
		ipv4->sin_family = AF_INET;
		ipv4->sin_port = htons((yyvsp[-9].integer));
		if (inet_pton(AF_INET, (yyvsp[-2].string), &ipv4->sin_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV4);
			(yyval.expression)->value.socket_address_ipv4 = ipv4;
		} else {
			free(ipv4);
			semantic_error("invalid IPv4 address");
		}
	} else if (strcmp((yyvsp[-15].string), "AF_INET6") == 0) {
		struct sockaddr_in6 *ipv6 = malloc(sizeof(struct sockaddr_in6));
		memset(ipv6, 0, sizeof(*ipv6));
		ipv6->sin6_family = AF_INET6;
		ipv6->sin6_port = htons((yyvsp[-9].integer));
		if (inet_pton(AF_INET6, (yyvsp[-2].string), &ipv6->sin6_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV6);
			(yyval.expression)->value.socket_address_ipv6 = ipv6;
		} else {
			free(ipv6);
			semantic_error("invalid IPv6 address");
		}
	}
}
#line 3924 "parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1598 "parser.y" /* yacc.c:1646  */
    {
	struct msghdr_expr *msg_expr = calloc(1, sizeof(struct msghdr_expr));
	(yyval.expression) = new_expression(EXPR_MSGHDR);
	(yyval.expression)->value.msghdr = msg_expr;
	msg_expr->msg_name	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_namelen	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_iov	= (yyvsp[-6].expression);
	msg_expr->msg_iovlen	= (yyvsp[-9].expression);
	msg_expr->msg_control	= (yyvsp[-1].expression);
	msg_expr->msg_flags	= (yyvsp[-2].expression);
}
#line 3940 "parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1612 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(EXPR_LIST); }
#line 3946 "parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1613 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 3952 "parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1619 "parser.y" /* yacc.c:1646  */
    {
	struct cmsg_expr *cmsg_expr = calloc(1, sizeof(struct cmsg_expr));
	(yyval.expression) = new_expression(EXPR_CMSG);
	(yyval.expression)->value.cmsg = cmsg_expr;
	cmsg_expr->cmsg_level = (yyvsp[-9].expression);
	cmsg_expr->cmsg_type  = (yyvsp[-5].expression);
	cmsg_expr->cmsg_data  = (yyvsp[-1].expression);
}
#line 3965 "parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1631 "parser.y" /* yacc.c:1646  */
    {
	struct scm_timestamping_expr *ts_expr =
		calloc(1, sizeof(struct scm_timestamping_expr));
	ts_expr->ts[0].tv_sec = (yyvsp[-5].integer);
	ts_expr->ts[0].tv_nsec = (yyvsp[-1].integer);

	(yyval.expression) = new_expression(EXPR_SCM_TIMESTAMPING);
	(yyval.expression)->value.scm_timestamping = ts_expr;
}
#line 3979 "parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1643 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = (yyvsp[-1].expression_list);
}
#line 3988 "parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1655 "parser.y" /* yacc.c:1646  */
    {
	struct sock_extended_err_expr *ee_expr =
		calloc(1, sizeof(struct sock_extended_err_expr));
	ee_expr->ee_errno = (yyvsp[-21].expression);
	ee_expr->ee_origin = (yyvsp[-17].expression);
	ee_expr->ee_type = (yyvsp[-13].expression);
	ee_expr->ee_code = (yyvsp[-9].expression);
	ee_expr->ee_info = (yyvsp[-5].expression);
	ee_expr->ee_data = (yyvsp[-1].expression);
	(yyval.expression) = new_expression(EXPR_SOCK_EXTENDED_ERR);
	(yyval.expression)->value.sock_extended_err = ee_expr;
}
#line 4005 "parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1670 "parser.y" /* yacc.c:1646  */
    {
	struct iovec_expr *iov_expr = calloc(1, sizeof(struct iovec_expr));
	(yyval.expression) = new_expression(EXPR_IOVEC);
	(yyval.expression)->value.iovec = iov_expr;
	iov_expr->iov_base = new_expression(EXPR_ELLIPSIS);
	iov_expr->iov_len = (yyvsp[-1].expression);
}
#line 4017 "parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1680 "parser.y" /* yacc.c:1646  */
    {
	struct pollfd_expr *pollfd_expr = calloc(1, sizeof(struct pollfd_expr));
	(yyval.expression) = new_expression(EXPR_POLLFD);
	(yyval.expression)->value.pollfd = pollfd_expr;
	pollfd_expr->fd = (yyvsp[-6].expression);
	pollfd_expr->events = (yyvsp[-2].expression);
	pollfd_expr->revents = (yyvsp[-1].expression);
}
#line 4030 "parser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1691 "parser.y" /* yacc.c:1646  */
    {
	struct epollev_expr *epollev_expr = calloc(1, sizeof(struct epollev_expr));
	(yyval.expression) = new_expression(EXPR_EPOLLEV);
	(yyval.expression)->value.epollev = epollev_expr;
	epollev_expr->events = (yyvsp[-5].expression);
	epollev_expr->fd = (yyvsp[-1].expression);
}
#line 4042 "parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1697 "parser.y" /* yacc.c:1646  */
    {
	struct epollev_expr *epollev_expr = calloc(1, sizeof(struct epollev_expr));
	(yyval.expression) = new_expression(EXPR_EPOLLEV);
	(yyval.expression)->value.epollev = epollev_expr;
	epollev_expr->events = (yyvsp[-5].expression);
	epollev_expr->ptr = (yyvsp[-1].expression);
}
#line 4054 "parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1703 "parser.y" /* yacc.c:1646  */
    {
	struct epollev_expr *epollev_expr = calloc(1, sizeof(struct epollev_expr));
	(yyval.expression) = new_expression(EXPR_EPOLLEV);
	(yyval.expression)->value.epollev = epollev_expr;
	epollev_expr->events = (yyvsp[-5].expression);
	epollev_expr->u32 = (yyvsp[-1].expression);
}
#line 4066 "parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1709 "parser.y" /* yacc.c:1646  */
    {
	struct epollev_expr *epollev_expr = calloc(1, sizeof(struct epollev_expr));
	(yyval.expression) = new_expression(EXPR_EPOLLEV);
	(yyval.expression)->value.epollev = epollev_expr;
	epollev_expr->events = (yyvsp[-5].expression);
	epollev_expr->u64 = (yyvsp[-1].expression);
}
#line 4078 "parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1719 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_integer_expression(0, "%ld"); }
#line 4084 "parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1720 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 4090 "parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1724 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LINGER);
	(yyval.expression)->value.linger.l_onoff  = (yyvsp[-5].integer);
	(yyval.expression)->value.linger.l_linger = (yyvsp[-1].integer);
}
#line 4100 "parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1733 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_MPLS_STACK);
	(yyval.expression)->value.mpls_stack = (yyvsp[-1].mpls_stack);
}
#line 4109 "parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1740 "parser.y" /* yacc.c:1646  */
    { (yyval.errno_info) = NULL; }
#line 4115 "parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1741 "parser.y" /* yacc.c:1646  */
    {
	(yyval.errno_info) = malloc(sizeof(struct errno_spec));
	(yyval.errno_info)->errno_macro = (yyvsp[-1].string);
	(yyval.errno_info)->strerror    = (yyvsp[0].string);
}
#line 4125 "parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1749 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 4131 "parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1750 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 4137 "parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1754 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[-1].string); }
#line 4143 "parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1758 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 4149 "parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1759 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("flags"); }
#line 4155 "parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1760 "parser.y" /* yacc.c:1646  */
    { asprintf(&((yyval.string)), "%s %s", (yyvsp[-1].string), (yyvsp[0].string)); free((yyvsp[-1].string)); free((yyvsp[0].string)); }
#line 4161 "parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1764 "parser.y" /* yacc.c:1646  */
    {
	(yyval.command) = malloc(sizeof(struct command_spec));
	(yyval.command)->command_line = (yyvsp[0].string);
	current_script_line = yylineno;
}
#line 4171 "parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1772 "parser.y" /* yacc.c:1646  */
    {
	(yyval.code) = calloc(1, sizeof(struct code_spec));
	(yyval.code)->text = (yyvsp[0].string);
	current_script_line = yylineno;
 }
#line 4181 "parser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1780 "parser.y" /* yacc.c:1646  */
    { }
#line 4187 "parser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1781 "parser.y" /* yacc.c:1646  */
    { }
#line 4193 "parser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1785 "parser.y" /* yacc.c:1646  */
    {
	out_script->cleanup_command = (yyvsp[0].command);
	cleanup_cmd = out_script->cleanup_command->command_line;
}
#line 4202 "parser.c" /* yacc.c:1646  */
    break;


#line 4206 "parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
